from hashlib import md5

import webcolors

def whatever_to_rgb(string):
    """
    Converts CSS3 color or a hex into rgb triplet; hash of string if fails.
    """
    string = string.strip().lower()
    try:
        return webcolors.name_to_rgb(string)
    except ValueError:
        try:
            return webcolors.hex_to_rgb(string)
        except ValueError:
            try:
                if string[:3] == "rgb":
                    return tuple([float(i) for i in string[4:-1].split(",")][0:3])
            except:
                return webcolors.hex_to_rgb("#" + md5(string).hexdigest()[:6])


def whatever_to_hex(string):
    if type(string) == tuple:
        return cairo_to_hex(string).upper()
    return webcolors.rgb_to_hex(whatever_to_rgb(string)).upper()


def whatever_to_cairo(string):
    a = whatever_to_rgb(string)
    return a[0] / 255., a[1] / 255., a[2] / 255.


def cairo_to_hex(cairo):
    return webcolors.rgb_to_hex((int(cairo[0] * 255), int(cairo[1] * 255), int(cairo[2] * 255)))
